commit edbe164af12589002dec6ac5fe92304567b0ab98
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Thu Nov 14 01:14:44 2024 +0000

    libstdc++: Add missing parts of LWG 3480 for directory iterators [PR117560]
    
    It looks like I only read half the resolution of LWG 3480 and decided we
    already supported it. As well as making the non-member overloads of end
    take their parameters by value, we need some specializations of the
    enable_borrowed_range and enable_view variable templates.
    
    libstdc++-v3/ChangeLog:
    
            PR libstdc++/117560
            * include/bits/fs_dir.h (enable_borrowed_range, enable_view):
            Define specializations for directory iterators, as per LWG 3480.
            * testsuite/27_io/filesystem/iterators/lwg3480.cc: New test.
    
    (cherry picked from commit eec6e8923586b9a54e37f32cef112d26d86e8f01)

diff --git a/libstdc++-v3/include/bits/fs_dir.h b/libstdc++-v3/include/bits/fs_dir.h
index d669f2a7468..79dc6764b7b 100644
--- a/libstdc++-v3/include/bits/fs_dir.h
+++ b/libstdc++-v3/include/bits/fs_dir.h
@@ -39,6 +39,7 @@
 #if __cplusplus >= 202002L
 # include <compare>	// std::strong_ordering
 # include <bits/iterator_concepts.h>	// std::default_sentinel_t
+# include <bits/ranges_base.h> // enable_view, enable_borrowed_range
 #endif
 
 namespace std _GLIBCXX_VISIBILITY(default)
@@ -626,6 +627,27 @@ _GLIBCXX_END_NAMESPACE_CXX11
   extern template class
     __shared_ptr<filesystem::recursive_directory_iterator::_Dir_stack>;
 
+#if __glibcxx_ranges // >= C++20
+// _GLIBCXX_RESOLVE_LIB_DEFECTS
+// 3480. directory_iterator and recursive_directory_iterator are not ranges
+namespace ranges
+{
+  template<>
+    inline constexpr bool
+    enable_borrowed_range<filesystem::directory_iterator> = true;
+  template<>
+    inline constexpr bool
+    enable_borrowed_range<filesystem::recursive_directory_iterator> = true;
+
+  template<>
+    inline constexpr bool
+    enable_view<filesystem::directory_iterator> = true;
+  template<>
+    inline constexpr bool
+    enable_view<filesystem::recursive_directory_iterator> = true;
+} // namespace ranges
+#endif // ranges
+
 _GLIBCXX_END_NAMESPACE_VERSION
 } // namespace std
 
diff --git a/libstdc++-v3/testsuite/27_io/filesystem/iterators/lwg3480.cc b/libstdc++-v3/testsuite/27_io/filesystem/iterators/lwg3480.cc
new file mode 100644
index 00000000000..15e0286fff6
--- /dev/null
+++ b/libstdc++-v3/testsuite/27_io/filesystem/iterators/lwg3480.cc
@@ -0,0 +1,16 @@
+// { dg-do compile { target c++20 } }
+// { dg-require-filesystem-ts "" }
+
+// LWG 3480
+// directory_iterator and recursive_directory_iterator are not C++20 ranges
+
+#include <filesystem>
+
+namespace fs = std::filesystem;
+namespace rg = std::ranges;
+
+static_assert( rg::borrowed_range<fs::directory_iterator> );
+static_assert( rg::borrowed_range<fs::recursive_directory_iterator> );
+
+static_assert( rg::view<fs::directory_iterator> );
+static_assert( rg::view<fs::recursive_directory_iterator> );

